import angr, angrop
p = angr.Project('test', auto_load_libs=False)
rop = p.analyses.ROP(fast_mode=False, only_check_near_rets=False)
rop.find_gadgets()

shift_gadget = rop.shift(8)
chain1 = rop.func_call('close', [0])
chain2 = rop.func_call('exit', [0])
final_chain = chain1 + chain2

print()
print()
print()
print('Since a "pop ds; ret;" gadget appeared early in the binary, it appears to be the default gadget for shifting 8 bytes on the stack.')
print('This is the result of rop.shift(8):')
print(shift_gadget)

print()
print()
print()
print('Now when we try to build a chain for a function call that only takes 1 argument, the stack needs to shift 8 bytes to clean up the argument off of the stack.')
print('This chain calls close(0) followed by exit(0):')
print(final_chain)

print()
print('The chain will fail. There is a cheat to see this failure by uncommenting the call to show_failure_scenario() in test.c.')
